proc NASTRANWindonsMat { } {
    
    GiD_DataBehaviour material Isotropic hide {delete}
    GiD_DataBehaviour material Anisotropic_Shell hide {delete}
    GiD_DataBehaviour material Orthotropic_Shell hide {delete}
    GiD_DataBehaviour materials Material hide {assign draw unassign}
    GiD_DataBehaviour materials Tables hide {assign draw unassign}
    GiD_DataBehaviour material Bar hide {delete}
    GiD_DataBehaviour material Beam hide {delete}
    GiD_DataBehaviour material Tube hide {delete}
    GiD_DataBehaviour material Pipe hide {delete}
    GiD_DataBehaviour material Cable hide {delete}
    GiD_DataBehaviour material Rod hide {delete}
    GiD_DataBehaviour material Shear_Panel hide {delete}
    GiD_DataBehaviour material Plate hide {delete}
    GiD_DataBehaviour material Viscous_Damper hide {delete}
    GiD_DataBehaviour material Laminate hide {delete}
    GiD_DataBehaviour material Spring hide {delete}
    GiD_DataBehaviour material DOF_Spring hide {delete}
    GiD_DataBehaviour material Tetrahedron hide {delete}
    GiD_DataBehaviour material Hexahedron hide {delete}
    GiD_DataBehaviour material Table hide {delete}
   
  }
 proc NastranBase2PostCmdAssignMat { GDN w Menu entitylabel entitytype } {
     $Menu del 0 end
     if { [catch { set whatuse [lindex [.gid.central.s info Project] 4] }] } {
	 set whatuse GEOMETRYUSE
     }
     switch $whatuse {
	 GEOMETRYUSE {
	     $Menu add command -label $entitylabel -command [list DWAssignMaterials $GDN $w $entitytype]
	 }
	 MESHUSE {
	     set entitylabel [= "Elements"]
	     set entitytype Elements
	     $Menu add command -label $entitylabel -command [list DWAssignMaterials $GDN $w $entitytype]
	 }
     }
 }
 proc NastranBasePostCmdAssignMat { GDN w Menu } {
	
     if { [::GidUtils::VersionCmp 7.4.1b] >= 0 } { 
	 set _MatName [DWGetCurrentMaterial $GDN] 
     } else {
	 upvar \#0 $GDN GidData
	 set _MatName [DWSpace2Under $GidData(MAT,matname)] ;#deprecated
     }
 
     set property [lindex [.central.s info Materials $_MatName] 4]
     set book [.central.s info Materials $_MatName BOOK]
 
     set LinesMats [list BAR BEAM TUBE VISCOUS_DAMPER SPRING DOF_SPRING ROD]
     set SurfacesMats [list PLATE SHEAR_PANEL LAMINATE ]
     set VolumesMats [list TETRAHEDRON HEXAHEDRON] 
     if { [lsearch $LinesMats $property] != -1 } {
	 NastranBase2PostCmdAssignMat $GDN $w $Menu [= "Lines"] "Lines"
     } elseif { [lsearch $SurfacesMats $property] != -1 } {
	 NastranBase2PostCmdAssignMat $GDN $w $Menu [= "Surfaces"] "Surfaces"
     } elseif { [lsearch $VolumesMats $property] != -1 } {
	 NastranBase2PostCmdAssignMat $GDN $w $Menu [= "Volumes"] "Volumes"
     } elseif { $book != "Material" && $book != "Tables"} {
	 NastranPostCmdAssignMat $GDN $w $Menu
     }
#    else {
#         $Menu del 0 end
#        $Menu add command -label [= "This material or table cannot be assigned"]
#     }
 }
proc NASTRANlaunch { } {

    package require registry
 
    if { [catch {registry get {HKEY_LOCAL_MACHINE\SOFTWARE\Noran Engineering\Engine} Path} aux] } {
	WarnWin [= "Unable to find NE/NASTRAN installation directory. Automatic Editor launch will be disable"]
    } else {
	set NASTRANPath [file join $aux Editor.exe]
#         set modelname [lindex [GiD_Info project] 1]
#         if { $modelname == "UNNAMED" } {
#             set filename [Browser-ramR project write .gid [= "Save Project"]] 
#             if { $filename == "" } return
#             GiD_Process escape escape escape escape Files SaveAs $filename
#         }
	if { [.central.s info Mesh]== 0 } {
	    WarnWin [= "Don't forget to generate the mesh"]
	    return
	}
	if { [lindex [GiD_Info project] 10]==1 } {
	    WarnWin [= "WARNING: Some changes have been made to geometry, conditions or materials. Mesh should probably be generated again."]
	}
#        set modelname [file join [lindex [GiD_Info project] 1].gid [file tail [lindex [GiD_Info project] 1]].nas]
	GidUtils::WaitState .gid 
	#        GiD_Process escape escape escape escape Files WriteCalcFile $modelname
	if { [WriteCalcFileCheck]!=0 } { 
	    set modelname [file join [lindex [GiD_Info project] 1].gid [file tail [lindex [GiD_Info project] 1]].nas]
	    exec $NASTRANPath $modelname >& NUL: &
	} 
	GidUtils::EndWaitState .gid
	
    }
}       


proc InitGIDProject { dir } {
    global ProgramName VersionNumber ProblemTypePriv NastranPriv
    global GidPriv
    
    catch { unset ProblemTypePriv }
    GiD_Set MaintainProblemTypeInNew 1
    set ProblemTypePriv(nastrantype) "GiD"
    if { $ProblemTypePriv(nastrantype)== "NENASTRAN"} { 
	set ProgramName [= "GiD-NEiFEA"]
	set VersionNumber 1.1
    } else {
	set ProgramName [= "GiD-NASTRAN"]
	set VersionNumber 3.2.2
    }
    
    set VersionRequired "8.0"
    set comp -1
    catch { 
	set comp [::GidUtils::VersionCmp $VersionRequired]
    }
    if { $comp < 0 } {
	WarnWin [= "Error: %s Interface requires GiD %s or later." $ProgramName $VersionRequired]
    }
    
    if { [info exists GidPriv(CalculationFileExtension)] } {
	set ProblemTypePriv(OldCalculationFileExtension) $GidPriv(CalculationFileExtension)
    }
    set GidPriv(CalculationFileExtension) ".nas"
    set ProblemTypePriv(problemtypedir) $dir
    
    catch {
	GidShowBook intvdata "" 0
    }
    NASTRANWindonsMat
    

    package require base64
    package require supergrid
    package require helpviewer
    
     if { [::GidUtils::VersionCmp 8.0.2] >= 0 } {
	foreach i [list nastranpch2gid.tcl function.tcl \
		tkcheckdata.tcl verify_properties.tcl \
		nasmat.tcl buttontable.tcl loadcases.tcl heatboundaries.tcl \
		convection.tcl nastogid.tcl nasmat_anisotropicshell.tcl nasmat_orthotropicshell.tcl \
		calcangle.tcl baswriter.tcl plate.tcl buttonmaterial.tcl materialsmatrixtemp.tcl \
		verifymodel.tcl nassections.tcl composite.tcl] {
	    source [file join $dir scripts $i]
	} 
    } else {
	#try deprecated style
	foreach i [list nastranpch2gid.tcl function.tcl \
		tkcheckdata.tcl verify_properties.tcl \
		nasmat.tcl buttontable.tcl loadcases.tcl heatboundaries.tcl \
		convection.tcl nastogid.tcl nasmat_anisotropicshell.tcl nasmat_orthotropicshell.tcl \
		calcangle.tcl baswriter.tcl plate.tcl buttonmaterial.tcl materialsmatrixtemp.tcl] {
	    source [file join $dir scripts $i]
	} 
	loadtbefile [file join $dir scripts verifymodel.tbe]
	loadtbefile [file join $dir scripts nassections.tbe]
	loadtbefile [file join $dir scripts composite.tbe]
    }
    
    if { [catch {
	LoadCasesInit $dir
    }] } {
	WarnWin [= "%s is not compatible with this GiD version" $ProgramName]
	return
    }
    
    foreach i [list PostCmdAssignMat] {
	if { [info command Nastran$i] == "" } {
	    rename $i Nastran$i
	    rename NastranBase$i $i
	}
    }
    
    if { ![info exists  NastranPriv(infosplash)] } {
	catch { Splash $dir }
	set NastranPriv(infosplash) 1
    }
    
    
    NastranBitmaps $dir
    
    set GidPriv(ProgName) $ProgramName
    ChangeWindowTitle
    
    UpdateMenusNastran
}



proc ChangedLanguage { newlanguange } {
    #to force refresh some menus managed by the problemtype when the user change to newlanguage
    UpdateMenusNastran
}

proc UpdateMenusNastran { } {
    global ProgramName VersionNumber ProblemTypePriv NastranPriv

    set dir $ProblemTypePriv(problemtypedir)

    if { [::GidUtils::VersionCmp 8.0] >= 0 } {
	foreach where {PRE POST} {
	    GiDMenu::InsertOption "Help#C#menu" [list [= "%s Interface tutorials" $ProgramName]] 0 $where \
		    [list GiDCustomHelp -dir [file join $dir .. info nastran_tutorials.html] \
		    -title [= "%s Interface tutorials" $ProgramName] -start nastran_tutorials.html -report 1] \
		    "" "" "insert"
	    GiDMenu::InsertOption "Help#C#menu" [list [= "%s Interface help" $ProgramName]] 0 $where \
		    [list GiDCustomHelp -dir [file join $dir .. info nastran_toc.html] \
		    -title [= "%s Interface help" $ProgramName] -start nastran_toc.html] \
		    "" "" "insert"
	    GiDMenu::InsertOption "Help#C#menu" [list [= "About %s Interface" $ProgramName]] end $where \
		    [list Splash $dir 0] \
		    "" "" "insertafter"
	}
	GiDMenu::ModifyOption  "Files#C#menu" [list "Export#C#menu" "Calculation file#C#menu"] PRE -default- \
		WriteCalcFileCheck -default- -default- 
    } else {
	#try deprecated style
	global MenuNames MenuEntries MenuCommands MenuAcceler
	global MenuNamesP MenuEntriesP MenuCommandsP MenuAccelerP
	set ipos [lsearch $MenuNames [_ "Help"]]
	if { $ipos != -1 } {
	    set MenuEntries($ipos) [linsert $MenuEntries($ipos) 0 [= "%s Interface tutorials" $ProgramName] \
		    [= "%s Interface help" $ProgramName]]
	    set MenuCommands($ipos) [linsert $MenuCommands($ipos) 0 \
		    [list -np- HelpWindow "CUSTOM_HELP_FILE" \
		    [file join $dir ../info nastran_tutorials.html]] \
		    [list -np- HelpWindow "CUSTOM_HELP_REFERENCE" \
		    [file join $dir ../info nastran_toc.html]]]
	    set MenuAcceler($ipos) [linsert $MenuAcceler($ipos) 0 "" ""]
	    
	    lappend MenuEntries($ipos) [= "About %s Interface" $ProgramName]
	    lappend MenuCommands($ipos) [list -np- Splash $dir 0]
	    lappend MenuAcceler($ipos) ""
	}
	set ipos [lsearch $MenuNamesP [_ "Help"]]
	if { $ipos != -1 } {
	    set MenuEntriesP($ipos) [linsert $MenuEntriesP($ipos) 0 [= "%s Interface tutorials" $ProgramName] \
		    [= "%s Interface help" $ProgramName] ]
	    set MenuCommandsP($ipos) [linsert $MenuCommandsP($ipos) 0 \
		    [list -np- HelpWindow "CUSTOM_HELP_FILE" \
		    [file join $dir ../info nastran_tutorials.html]] \
		    [list -np- HelpWindow "CUSTOM_HELP_REFERENCE" \
		    [file join $dir ../info nastran_toc.html]]]
	    set MenuAccelerP($ipos) [linsert $MenuAccelerP($ipos) 0 "" ""]
	    
	    lappend MenuEntriesP($ipos) [= "About %s Interface" $ProgramName]
	    lappend MenuCommandsP($ipos) [list -np- Splash $dir 0]
	    lappend MenuAccelerP($ipos) ""
	}
	
	set ipos [lsearch $MenuNames [_ "Files"]]
	if { $ipos != -1 } {
	    set ipos2 [lsearch $MenuEntries($ipos) [_ "*Export*"] ]
	    if { $ipos2 != -1 } {
		set ipos3 [lsearch $MenuEntries($ipos,$ipos2) [_ "*Calculation file*"] ]
		if { $ipos3 != -1 } {
		    set MenuCommands($ipos,$ipos2) [lreplace $MenuCommands($ipos,$ipos2) \
			    $ipos3 $ipos3 "-np- WriteCalcFileCheck"]
		}
	    }
	}
    }

    if { [::GidUtils::VersionCmp 8.0.2] >= 0 } {
	#GiDMenu::InsertOption from 8.0 until 8.0.2 has a bug when inserting in POST menus and 
        #          and this menu were inserted at Export instead Import   
	
	#now this message is unnecessary, GiD can read FEMAP neutral ASCII and binary
	#GiDMenu::InsertOption "Files#C#menu" [list "Import#C#menu" [= "FEMAP Info"]...] end POST \
	#	[list FemapInfo] "" "" "insertafter"
	GiDMenu::InsertOption "Files#C#menu" [list "Import#C#menu" [= "Import PUNCH"]...] end POST \
		[list PCH2GiD $dir 1 0] "" "" "insertafter"
	GiDMenu::InsertOption "Files#C#menu" [list "Import#C#menu" [= "Import PUNCH(Smooth)"]...] end POST \
		[list PCH2GiD $dir 1 1] "" "" "insertafter"
    } else {
	#try deprecated style
	global MenuNames MenuEntries MenuCommands MenuAcceler
	global MenuNamesP MenuEntriesP MenuCommandsP MenuAccelerP
	set ipos [lsearch $MenuNamesP [_ "Files"]]
	set iposin [lsearch $MenuEntriesP($ipos) [_ "Import"]]
	if { [::GidUtils::VersionCmp 8.0] < 0 } {
	    #now this message is unnecessary, GiD can read FEMAP neutral ASCII and binary
	    #GiDMenu::InsertOption "Files#C#menu" [list "Import#C#menu" [= "FEMAP Info"]...] end POST \
		    #	[list FemapInfo] "" "" "insertafter"
	    set MenuEntriesP($ipos,$iposin) [linsert $MenuEntriesP($ipos,$iposin) 2 [= "FEMAP Info"]...]
	    set MenuCommandsP($ipos,$iposin) [linsert $MenuCommandsP($ipos,$iposin) 2 [list -np- FemapInfo ]]
	}
	set MenuEntriesP($ipos,$iposin) [linsert $MenuEntriesP($ipos,$iposin) 3 [= "Import PUNCH"]]
	set MenuCommandsP($ipos,$iposin) [linsert $MenuCommandsP($ipos,$iposin) 3 [list -np- PCH2GiD $dir 1 0]]
	set MenuEntriesP($ipos,$iposin) [linsert $MenuEntriesP($ipos,$iposin) 4 [= "Import PUNCH(Smooth)"]]
	set MenuCommandsP($ipos,$iposin) [linsert $MenuCommandsP($ipos,$iposin) 4 [list -np- PCH2GiD $dir 1 1]]
	#set MenuAccelerP($ipos,$iposin) [linsert $MenuAccelerP($ipos,$iposin) 2 ""]
	set GidVersion [.gid.central.s info GiDVersion]
	set GidVersion [string trim $GidVersion]
	set GidVersion [string index $GidVersion 0]
	if { $GidVersion <= 6 } {
	    set iposin2 [lsearch $MenuEntriesP($ipos,$iposin) [_ "Image"]]
	    set MenuEntriesP($ipos,$iposin,$iposin2) $MenuEntriesP($ipos,$iposin,[expr $iposin2-2])
	    catch {unset MenuEntriesP($ipos,$iposin,[expr $iposin2-2])}
	    set MenuCommandsP($ipos,$iposin,$iposin2) $MenuCommandsP($ipos,$iposin,[expr $iposin2-2])
	    catch {unset MenuCommandsP($ipos,$iposin,[expr $iposin2-2])}
	}
    }

    #UpdateDataOptionsNastran
    #to force refresh some menus managed by the problemtype when the user change to newlanguage
    DWInitUserDataOptions ;#reset default options

    GidChangeDataLabel "Problem Data" ""
    GidChangeDataLabel "Conditions" ""
    GidChangeDataLabel "Materials" ""
    GidChangeDataLabel "Interval" ""
    GidChangeDataLabel "Interval Data" ""
    
    GidAddUserDataOptions [= "Load cases"] "LoadCaseWindow" 2
    GidAddUserDataOptionsMenu [= "Boundary Conditions"] "NastranBoundaryconditionsSubmenu %W" 3
    GidAddUserDataOptionsMenu [= "Loads"] "NastranLoadsSubmenu %W" 4
    GidAddUserDataOptions [= "Advanced Conditions"] "GidOpenConditions Advanced_Conditions" 5
    GidAddUserDataOptions [= "Materials"] "GidOpenMaterials Material" 6
    GidAddUserDataOptionsMenu [= "Properties"] "NastranPropertiesSubmenu %W" 7
    GidAddUserDataOptionsMenu [= "Analysis Design"] "NastranAnalysisSubmenu %W" 8
    GidAddUserDataOptionsMenu [= "Problem data"] "NastranProblemdataSubmenu %W" 9
    GidAddUserDataOptions [= "Verify Properties"] VerifyProperty 10
    GidAddUserDataOptions "---" "" 11  

    CreateTopMenus ;#apply menu changes
}

proc NastranPropertiesSubmenu { w } {
    $w del 0 end
    $w add command -label [= "Property"] -command [list GidOpenMaterials Property ]
    $w add command -label [= "Local Axes"] -command [list GidOpenConditions Local_Axes ]
    $w configure -postcommand ""
}
proc NastranLoadsSubmenu { w } {
    $w del 0 end
    $w add command -label [= "Static Loads"] -command [list GidOpenConditions Static_Loads ]
    $w add command -label [= "Dynamics Loads"] -command [list GidOpenConditions Dynamics_Loads ]
    $w add command -label [= "Thermal Loads"] -command [list GidOpenConditions Thermal_Loads ]
    $w add command -label [= "Tables"] -command [list GidOpenMaterials Tables ]
    $w configure -postcommand ""
}
proc NastranBoundaryconditionsSubmenu { w } {
    $w del 0 end
    $w add command -label [= "Constraints"] -command [list GidOpenConditions Constraints ]
    $w add command -label [= "Connections"] -command [list GidOpenConditions Connections ]
     $w add command -label [= "Heat Boundaries"] -command [list GidOpenConditions Heat_Boundaries ]
    $w configure -postcommand ""
}
proc NastranProblemdataSubmenu { w } {
    $w del 0 end
    $w add command -label [= "Executive Control"] -command [list GidOpenProblemData Executive_Control]
    $w add command -label [= "Case Control"] -command [list GidOpenProblemData Case_Control]
    $w add command -label [= "Parameters"] -command [list GidOpenProblemData Parameters]
    $w configure -postcommand ""
}
proc NastranAnalysisSubmenu { w } {
    $w del 0 end
    $w add command -label [= "Thermal"] -command [list GidOpenProblemData Thermal]
    $w add command -label [= "Dynamics"] -command [list GidOpenProblemData Dynamics]
    $w add command -label [= "Buckling"] -command [list GidOpenProblemData Buckling]
    $w add command -label [= "NonLinear"] -command [list GidOpenProblemData NonLinear]
    $w configure -postcommand ""
}


proc EndGIDProject {} {
    global ProblemTypePriv
    
    if { [info exists ProblemTypePriv(condfuns)] } {
	foreach i $ProblemTypePriv(condfuns) {
	    catch { rename $i {} }
	    catch { rename $i-base $i }
	}
    }
    catch { destroy .gid.loadcases }
    foreach i [list PostCmdAssignMat DWDrawMaterials DWUnassignMat] {
	if { [info command Nastran$i] != "" } {
	    catch {rename $i "" }
	    catch { rename Nastran$i $i }
	}
    }
    global GidPriv
    set GidPriv(ProgName) GiD
    ChangeWindowTitle ""
    EndNastranBitmaps
    if { [info exists ProblemTypePriv(OldCalculationFileExtension)] } {
	set GidPriv(CalculationFileExtension) $ProblemTypePriv(OldCalculationFileExtension)
    } else {
	unset GidPriv(CalculationFileExtension)
    }
}



proc Splash { dir { autodestroy 1 } } {
    global GIDDEFAULT VersionNumber ProgramName
    global ProblemTypePriv

    if { [.gid.central.s disable windows] } { return }

    if { [ winfo exist .splash]} {
	destroy .splash
	update
    }

    toplevel .splash
    wm withdraw .splash
    if { $ProblemTypePriv(nastrantype) =="NENASTRAN" } {
	set im [image create photo -file [ file join $dir images neopen.gif]]
    } else {
	set im [image create photo -file [ file join $dir images nasopen.gif]]
    }
    set x [expr [winfo screenwidth .splash]/2-[image width $im]/2]
    set y [expr [winfo screenheight .splash]/2-[image height $im]/2]

    wm geom .splash +$x+$y
    wm transient .splash .gid
    wm overrideredirect .splash 1
    pack [label .splash.l -image $im -relief ridge -bd 2]
    
    label .splash.lv -text $VersionNumber -foreground white -relief raised -bd 3 \
	    -background blue4 -font "verdana 8"
    place .splash.lv -x 62 -y 62
    bind .splash <1> "destroy .splash"
    bind .splash <KeyPress> "destroy .splash"
    grab .splash
    focus .splash
    update
    wm deiconify .splash
    raise .splash .gid
    update
    if { $autodestroy } {
	after 4000 "if { [ winfo exist .splash] } { 
	    destroy .splash
	}"
    }
    
}

proc PCH2GiD { dir reenterpost  smooth } {

    global DefaultSearchDirectory

    if { ![info exists DefaultSearchDirectory] || \
	     ![file isdirectory $DefaultSearchDirectory]} {
	set DefaultSearchDirectory [pwd]
    }
    set deft $DefaultSearchDirectory

    set types [list \
	    [list [= "PUNCH files"] .pch] \
	    [list [= "All files"] *]]

    #set filein [tk_getOpenFile -defaultextension ".pch"  -initialdir $deft -parent .gid -filetypes $types]
    set filein [Browser-ramR file read .gid [= "Load PUNCH files"] $deft $types "" 0]
    
    if { $filein == "" } {
	return
    }
    set DefaultSearchDirectory [file dirname $filein]

    set aa [.central.s info Project]
    set ProjectName [lindex $aa 1]
    if { [file extension $ProjectName] == ".gid" } {
	set ProjectName [file root $ProjectName]
    }
    if { $ProjectName == "UNNAMED" } {
	tk_dialogRAM .gid.tmpwin error \
		  [= "Before importing, a project title is needed. Save project to get it"] \
		  error 0 OK
	  return
    }

    set directory $ProjectName.gid
    if { [file pathtype $directory] == "relative" } {
	set directory [file join [pwd] $directory]
    }
    set fileout [file join $directory [file root [file tail $ProjectName]].flavia.res]
    
    PCH2GiD::TranslateW  $filein $fileout $smooth
    
    if { $reenterpost } {
	set DisableGraphics [.central.s disable graphics]
	set DisableWarnLine [.central.s disable warnline]
	.central.s disable graphics 1
	.central.s disable warnline 1
	.central.s process escape escape escape escape preprocess yes 
	.central.s process escape escape escape escape postprocess yes
	if { !$DisableGraphics } { .central.s disable graphics 0 }
	if { !$DisableWarnLine } { .central.s disable warnline 0 }
    }
}

proc FemapInfo { } {

    tk_dialogRAMFull .gid.alele {information window} \
	[= "It is only possible to import FEMAP\nneutral files in ASCII format. \
	To obtain a FEMAP ASCII file in NE/NASTRAN go to NASTRAN Editor: \
	Menu Setup, Default Analysis Options. \
	Select RSLTFILETYPE,FEMAP ASCII in Output Control Directives."] \
	"" "" gidquestionhead 0 OK 
}

proc NastranBitmaps { dir { type "DEFAULT INSIDELEFT"} } {
    global NastranBitmapsNames NastranBitmapsCommands NastranBitmapsHelp ProblemTypePriv ProgramName

    set NastranBitmapsNames(0) "images/l1.gif images/constraints.gif \
	images/heatboundaries.gif --- images/loads.gif images/dynamicloads.gif \
	images/thermalloads.gif --- \
	images/section.gif images/localaxes.gif --- \
	images/executivecontrol.gif images/casecontrol.gif --- images/dynamics.gif \
	images/buckling.gif images/nonlinear.gif --- images/mesh.gif images/calculate.gif" 
    if {$ProblemTypePriv(nastrantype) == "NENASTRAN" } { 
	set NastranBitmapsCommands(0) [list {} [list -np- GidOpenConditions Constraints] \
		[list -np- GidOpenConditions Heat_Boundaries] \
		"" \
		[list -np- GidOpenConditions Static_Loads] \
		[list -np- GidOpenConditions Dynamics_Loads] \
		[list -np- GidOpenConditions Thermal_Loads] \
		"" \
		[list -np- GidOpenMaterials Property] \
		[list -np- GidOpenConditions Local_Axes] \
		"" \
		[list -np- GidOpenProblemData Executive_Control] \
		[list -np- GidOpenProblemData Case_Control] \
		"" \
		[list -np- GidOpenProblemData Dynamics] \
		[list -np- GidOpenProblemData Buckling] \
		[list -np- GidOpenProblemData  NonLinear] \
		"" \
		"Meshing generate" \
		[list -np- NASTRANlaunch]]
    } else {
	set NastranBitmapsCommands(0) [list {} [list -np- GidOpenConditions Constraints] \
		[list -np- GidOpenConditions Heat_Boundaries] \
		"" \
		[list -np- GidOpenConditions Static_Loads] \
		[list -np- GidOpenConditions Dynamics_Loads] \
		[list -np- GidOpenConditions Thermal_Loads] \
		"" \
		[list -np- GidOpenMaterials Property] \
		[list -np- GidOpenConditions Local_Axes] \
		"" \
		[list -np- GidOpenProblemData Executive_Control] \
		[list -np- GidOpenProblemData Case_Control] \
		"" \
		[list -np- GidOpenProblemData Dynamics] \
		[list -np- GidOpenProblemData Buckling] \
		[list -np- GidOpenProblemData  NonLinear] \
		"" \
		"Meshing generate" \
		[list -np- WriteCalcFileCheck]] 
    }
    set NastranBitmapsHelp(0) [list \
	    "" \
	    [= "Assign Constraints"] \
	    [= "Assign Heat Boundaries"] \
	    "" \
	    [= "Assign Static Loads"] \
	    [= "Assign Dynamic Loads"] \
	    [= "Assign Thermal Loads"] \
	    "" \
	    [= "Assign Properties"] \
	    [= "Define Local Axes for 1-D elements\nDefine Material Orientation."] \
	    "" \
	    [= "Define parameters of Executive Control section"] \
	    [= "Define parameters of Case Control section"] \
	    "" \
	    [= "Define parameters of Dynamic Analysis"] \
	    [= "Define parameters of Buckling Analysis"] \
	    [= "Define parameters of NonLinear Analysis"] \
	    "" \
	    [= "Generate Mesh" "Write Nastran Input file"]]
    
     set NastranBitmapsNames(0,0) ""
     set NastranBitmapsCommands(0,0) ""

    # prefix values:
    #          Pre        Only active in the preprocessor
    #          Post       Only active in the postprocessor
    #          PrePost    Active Always

    set prefix Pre

    set ProblemTypePriv(toolbarwin) [CreateOtherBitmaps NastranBar [= "Nastran toolbar"] \
	    NastranBitmapsNames NastranBitmapsCommands \
	    NastranBitmapsHelp $dir "NastranBitmaps [list $dir]" $type $prefix]
    set title [= "Nastran toolbar"]
    AddNewToolbar "$ProgramName bar" ${prefix}NastranBarWindowGeom "NastranBitmaps [list $dir]" $title

    # button number 3
     set ProblemTypePriv(loadcasewin) $ProblemTypePriv(toolbarwin).0
 
     if { [info exists ProblemTypePriv(loadcaseimg1)] } {
	 ChangeToLoadCase 1
     }

}

proc EndNastranBitmaps {} {
    global ProblemTypePriv ProgramName
    
    ReleaseToolbar "$ProgramName bar"
    rename NastranBitmaps ""
    
    catch { destroy $ProblemTypePriv(toolbarwin) }
}

# proc AfterMeshGeneration { fail } {
#     #assumed quadrilateral of 4 nodes, not checked
#     #not cheched conditions or materials
#     GidUtils::DisableGraphics
#     set epsilon2 1e-30
#     set elems [.central.s info mesh elements quadrilateral]
#     set  materials [GiD_Info materials]
#     foreach {num n(0) n(1) n(2) n(3) mat} $elems {
#         for {set i 0} { $i < 4 } { incr i } {
#             set c($i) [lindex [.central.s info Coordinates $n($i) mesh] 0]
#         }
#         set c(4) $c(0)
#         for {set i 0} { $i < 4 } { incr i } {
#             if { [MathUtils::VectorDistance2 $c($i) $c([expr $i+1])] < $epsilon2 } {
#                 if { $i == 0 } {
#                     set nodes "$n(1) $n(2) $n(3)"
#                 } elseif { $i == 1 } {
#                     set nodes "$n(2) $n(3) $n(0)"
#                 } elseif { $i == 2 } {
#                     set nodes "$n(3) $n(0) $n(1)"
#                 } else {
#                     set nodes "$n(0) $n(1) $n(2)"
#                 }
#                 GiD_Mesh delete element $num
#                 set matname [lindex $materials [expr $mat-1]]
#                 if { $matname != "" } {
#                     GiD_Mesh create element $num triangle 3 $nodes $matname
#                 } else {
#                     GiD_Mesh create element $num triangle 3 $nodes
#                 }
#                 break
#             }
#         }
#     }
#     GidUtils::EnableGraphics
# }



    

